﻿function getAngle(posA,posB){

	var vec1 = posB[0] - posA[0];
	var vec2 = posB[1] - posA[1];
	var vec3 = posB[2] - posA[2];


	var myAngle = Math.atan(vec2/vec1);
	var B = 0;

	if(vec1 >= 0&& vec2 >= 0){
		 B = 0;
	}else if(vec1 < 0&& vec2 >= 0){
		B = 180;
	}else if(vec1 < 0&& vec2 < 0){
		B = 180;
	}else if(vec1 >= 0&& vec2 < 0){
		B = 360;
	}

var  output = (57.2957* myAngle)+B;

return output;
}



function applyIK(type){
	
	var selectedLayers = app.project.activeItem.selectedLayers;
	if(!(selectedLayers.length == 5)){
		alert("Choose 5 layers, in the following order(root,upperLimb,lowerLimb,hand,effector) :-)Mads Juul");
	}else{
		function getLimbExpression(isUpper,effectorName,IKenabledName,upperName,lowerName,handName,elbowName){
			var string = "\
			if(thisComp.layer('"+effectorName+"').effect('"+IKenabledName+"')('Checkbox')==true){\
				cw = false;\
				upper = "+isUpper+";\
				upperLimb = '"+upperName+"';\
				lowerLimb = '"+lowerName+"'\;\
				extremity = '"+handName+"';\
				effector = '"+effectorName+"';\
				if (thisComp.layer('"+effectorName+"').effect('"+elbowName+"')('Checkbox') == 1){\
					cw = true;\
				}\
				function getWorldPos(theLayerName){\
					var L = thisComp.layer(theLayerName);\
					return L.toWorld(L.anchorPoint);\
				}\
				A = getWorldPos(upperLimb);\
				B = getWorldPos(lowerLimb);\
				C = getWorldPos(extremity);\
				E = getWorldPos(effector);\
				a = length(B,C);\
				b = length(E,A);\
				c = length(A,B);\
				x = (b*b + c*c - a*a )/(2*b);\
				alpha = Math.acos(clamp(x/c,-1,1));\
				if (upper){\
				  D = E - A;\
				  delta = Math.atan2(D[1],D[0]);\
				  result = radiansToDegrees(delta - (cw ? 1 : -1)*alpha);\
				  V = B - A;\
				  adj1 = radiansToDegrees(Math.atan2(V[1],V[0]));\
				  result - adj1 + value;\
				}else{\
				  y = b - x;\
				  gamma = Math.acos(clamp(y/a,-1,1));\
				  result = (cw ? 1 : -1)*radiansToDegrees(gamma + alpha);\
				  V1 = B - A;\
				  adj1 = radiansToDegrees(Math.atan2(V1[1],V1[0]));\
				  V2 = C - B;\
				  adj2 = radiansToDegrees(Math.atan2(V2[1],V2[0]));\
				  result +  adj1 - adj2 + value;\
				}\
			}else{\
				transform.rotation;\
			}\
			";
			return string;
		}
		
		app.beginUndoGroup("IK_Setup");
		try{
		var root = selectedLayers[0];
		var rootName = root.name;
		var upperLimb  = selectedLayers[1];
		var upperName = upperLimb.name;
		var lowerLimb  = selectedLayers[2];
		var lowerName = lowerLimb.name;
		var hand  = selectedLayers[3]
		var handName = hand.name;
		var effector  = selectedLayers[4];
		var effectorName = effector.name
		//unparent and Parent
		for(i = 0;i<5;i++){
			selectedLayers[i].parent = null;
		}
		upperLimb.parent = root;
		lowerLimb.parent = upperLimb;
		hand.parent = lowerLimb;
		
		//Add ekspession Controls to effector
		var IKenabledName = hand.name +'_IK_enable';
		
		//does it exists
		var IKenabledBox = effector("Effects").property(IKenabledName);
		if(IKenabledBox==null){
			var IKenabledBox = effector("Effects").addProperty("Checkbox Control");
			IKenabledBox.name = IKenabledName;
			
			IKenabledBox.property("Checkbox").addKey(0);
			IKenabledBox.property("Checkbox").setValueAtTime(0,1);
			//IKenabledBox.property("Checkbox").setInterpolationTypeAtKey(1,KeyframeInterpolationType.LINEAR,KeyframeInterpolationType.HOLD);
		}

		var elbowName = hand.name +'_elbow';
		var ex = effector("Effects").property(elbowName);
		if(ex==null){
			var elbowBox = effector("Effects").addProperty("Checkbox Control");
			elbowBox.name =elbowName;
		}
		
		if(type=='leg'){
			var angleName = hand.name +'_Angle';
			var angleControl = effector("Effects").property(angleName);
			if(angleControl==null){
				var angleControl = effector("Effects").addProperty("Angle Control");
				angleControl.name =angleName;
			}
			
		}
	
	
		var upperLimbExp = getLimbExpression("true",effectorName,IKenabledName,upperName,lowerName,handName,elbowName);
		upperLimb.rotation.expression = (upperLimbExp);
		upperLimb.rotation.expressionEnabled = true;
		var lowerLimbExp = getLimbExpression("false",effectorName,IKenabledName,upperName,lowerName,handName,elbowName);
		lowerLimb.rotation.expression = (lowerLimbExp);
		lowerLimb.rotation.expressionEnabled = true;
		if(type=="leg"){
			hand("Effects").addProperty("Transform");
		
			hand("Effects").property("Transform").property("Rotation").expression = ("\
				if(thisComp.layer('"+effectorName+"').effect('"+IKenabledName+"')('Checkbox')==true){\
				v = toWorldVec([1,0,0]);\
				-radiansToDegrees(Math.atan2(v[1],v[0]))+thisComp.layer('"+effectorName+"').effect('"+angleName+"')('Angle')+90;\
				} else{\
				0;\
				}\
			");
			hand("Effects").property("Transform").property("Anchor Point").expression = ("anchorPoint");
			hand("Effects").property("Transform").property("Position").expression = ("anchorPoint");
		}
		
		} catch(e){
			alert(e.line+"::"+e.message);
		}
		
	app.endUndoGroup();
	}
}


function createEffector(){
		var myComp = app.project.activeItem;
		var selectedLayers = app.project.activeItem.selectedLayers;
		if(selectedLayers.length == 1){
			try{
			var myHand = selectedLayers[0];
			var width = myHand.width;
			var height = myHand.height;
			var position = myHand.position.value;
			var name = myHand.name;
		
			var myEffector = myComp.layers.addSolid([1,0,0], name+"_effector", 50, 50, myComp.pixelAspect , myComp.duration);
			myEffector.parent = myHand.parent;
			myEffector.position.setValue(position);
			myEffector.moveAfter(myHand);
			myEffector.guideLayer = true;
			myEffector.parent = null;
			} catch(e){
				alert(e.line+":"+e.message);
				}
		} else {
			alert("Select only the Hand or foot Layer of the Limb you want to create an effector for ");
		}
	}

function createUI(thisObj) {

	var UIPanelRef = (thisObj instanceof Panel) ? thisObj : new Window("palette", "IK apply Panel",undefined, {resizeable:true});	
	if (UIPanelRef != null){
		resourcei = 
		"group { \
			orientation:'column', alignment:['top','left'], \
			apply: Panel { \
				orientation:'row', \
				alignment:['fill','top'], \
				text: 'Apply IK', \
				arm: Button { text: 'Arm'},\
				leg: Button { text: 'Leg'},\
			},  \
			effectorCreate: Panel { \
				orientation:'row', \
				alignment:['fill','top'], \
				text: 'Create Effector', \
				bt: Button { text: 'Create'},\
			},  \
		}";
		
	}
	
	UIPanelRef.grp = UIPanelRef.add(resourcei);
	UIPanelRef.layout.layout(true);
	
	UIPanelRef.grp.apply.arm.onClick = function(){
			applyIK("arm");
		
		}
	UIPanelRef.grp.apply.leg.onClick = function(){
			applyIK("leg");
	}
	UIPanelRef.grp.effectorCreate.bt.onClick = function(){
			createEffector();
	}
	
	return UIPanelRef;
}


//Main Script

	
//************MAIN SCRIPT
//Variable declaration

var IKPanel = createUI(this);




	

